<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CalculateSurchargeAmountResponse StructType
 * @subpackage Structs
 */
class CalculateSurchargeAmountResponse extends AbstractStructBase
{
    /**
     * The IsSurchargeEnabled
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IsSurchargeEnabled;
    /**
     * The IsSurchargeAllowedForZipCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IsSurchargeAllowedForZipCode;
    /**
     * The IsSurchargeAllowedForPaymentMethod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IsSurchargeAllowedForPaymentMethod;
    /**
     * The CalculateSurchargeAmountResult
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\CalculateSurchargeAmountResponse
     */
    public $CalculateSurchargeAmountResult;
    /**
     * The SurchargePercentage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SurchargePercentage;
    /**
     * The SurchargeAmount
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SurchargeAmount;
    /**
     * The SurchargeCaption
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SurchargeCaption;
    /**
     * The SurchargeTermsNote
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SurchargeTermsNote;
    /**
     * Constructor method for CalculateSurchargeAmountResponse
     * @uses CalculateSurchargeAmountResponse::setIsSurchargeEnabled()
     * @uses CalculateSurchargeAmountResponse::setIsSurchargeAllowedForZipCode()
     * @uses CalculateSurchargeAmountResponse::setIsSurchargeAllowedForPaymentMethod()
     * @uses CalculateSurchargeAmountResponse::setCalculateSurchargeAmountResult()
     * @uses CalculateSurchargeAmountResponse::setSurchargePercentage()
     * @uses CalculateSurchargeAmountResponse::setSurchargeAmount()
     * @uses CalculateSurchargeAmountResponse::setSurchargeCaption()
     * @uses CalculateSurchargeAmountResponse::setSurchargeTermsNote()
     * @param bool $isSurchargeEnabled
     * @param bool $isSurchargeAllowedForZipCode
     * @param bool $isSurchargeAllowedForPaymentMethod
     * @param \eBizCharge\StructType\CalculateSurchargeAmountResponse $calculateSurchargeAmountResult
     * @param string $surchargePercentage
     * @param string $surchargeAmount
     * @param string $surchargeCaption
     * @param string $surchargeTermsNote
     */
    public function __construct($isSurchargeEnabled = null, $isSurchargeAllowedForZipCode = null, $isSurchargeAllowedForPaymentMethod = null, \eBizCharge\StructType\CalculateSurchargeAmountResponse $calculateSurchargeAmountResult = null, $surchargePercentage = null, $surchargeAmount = null, $surchargeCaption = null, $surchargeTermsNote = null)
    {
        $this
            ->setIsSurchargeEnabled($isSurchargeEnabled)
            ->setIsSurchargeAllowedForZipCode($isSurchargeAllowedForZipCode)
            ->setIsSurchargeAllowedForPaymentMethod($isSurchargeAllowedForPaymentMethod)
            ->setCalculateSurchargeAmountResult($calculateSurchargeAmountResult)
            ->setSurchargePercentage($surchargePercentage)
            ->setSurchargeAmount($surchargeAmount)
            ->setSurchargeCaption($surchargeCaption)
            ->setSurchargeTermsNote($surchargeTermsNote);
    }
    /**
     * Get IsSurchargeEnabled value
     * @return bool
     */
    public function getIsSurchargeEnabled()
    {
        return $this->IsSurchargeEnabled;
    }
    /**
     * Set IsSurchargeEnabled value
     * @param bool $isSurchargeEnabled
     * @return \eBizCharge\StructType\CalculateSurchargeAmountResponse
     */
    public function setIsSurchargeEnabled($isSurchargeEnabled = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSurchargeEnabled) && !is_bool($isSurchargeEnabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isSurchargeEnabled, true), gettype($isSurchargeEnabled)), __LINE__);
        }
        $this->IsSurchargeEnabled = $isSurchargeEnabled;
        return $this;
    }
    /**
     * Get IsSurchargeAllowedForZipCode value
     * @return bool
     */
    public function getIsSurchargeAllowedForZipCode()
    {
        return $this->IsSurchargeAllowedForZipCode;
    }
    /**
     * Set IsSurchargeAllowedForZipCode value
     * @param bool $isSurchargeAllowedForZipCode
     * @return \eBizCharge\StructType\CalculateSurchargeAmountResponse
     */
    public function setIsSurchargeAllowedForZipCode($isSurchargeAllowedForZipCode = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSurchargeAllowedForZipCode) && !is_bool($isSurchargeAllowedForZipCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isSurchargeAllowedForZipCode, true), gettype($isSurchargeAllowedForZipCode)), __LINE__);
        }
        $this->IsSurchargeAllowedForZipCode = $isSurchargeAllowedForZipCode;
        return $this;
    }
    /**
     * Get IsSurchargeAllowedForPaymentMethod value
     * @return bool
     */
    public function getIsSurchargeAllowedForPaymentMethod()
    {
        return $this->IsSurchargeAllowedForPaymentMethod;
    }
    /**
     * Set IsSurchargeAllowedForPaymentMethod value
     * @param bool $isSurchargeAllowedForPaymentMethod
     * @return \eBizCharge\StructType\CalculateSurchargeAmountResponse
     */
    public function setIsSurchargeAllowedForPaymentMethod($isSurchargeAllowedForPaymentMethod = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSurchargeAllowedForPaymentMethod) && !is_bool($isSurchargeAllowedForPaymentMethod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isSurchargeAllowedForPaymentMethod, true), gettype($isSurchargeAllowedForPaymentMethod)), __LINE__);
        }
        $this->IsSurchargeAllowedForPaymentMethod = $isSurchargeAllowedForPaymentMethod;
        return $this;
    }
    /**
     * Get CalculateSurchargeAmountResult value
     * @return \eBizCharge\StructType\CalculateSurchargeAmountResponse|null
     */
    public function getCalculateSurchargeAmountResult()
    {
        return $this->CalculateSurchargeAmountResult;
    }
    /**
     * Set CalculateSurchargeAmountResult value
     * @param \eBizCharge\StructType\CalculateSurchargeAmountResponse $calculateSurchargeAmountResult
     * @return \eBizCharge\StructType\CalculateSurchargeAmountResponse
     */
    public function setCalculateSurchargeAmountResult(\eBizCharge\StructType\CalculateSurchargeAmountResponse $calculateSurchargeAmountResult = null)
    {
        $this->CalculateSurchargeAmountResult = $calculateSurchargeAmountResult;
        return $this;
    }
    /**
     * Get SurchargePercentage value
     * @return string|null
     */
    public function getSurchargePercentage()
    {
        return $this->SurchargePercentage;
    }
    /**
     * Set SurchargePercentage value
     * @param string $surchargePercentage
     * @return \eBizCharge\StructType\CalculateSurchargeAmountResponse
     */
    public function setSurchargePercentage($surchargePercentage = null)
    {
        // validation for constraint: string
        if (!is_null($surchargePercentage) && !is_string($surchargePercentage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($surchargePercentage, true), gettype($surchargePercentage)), __LINE__);
        }
        $this->SurchargePercentage = $surchargePercentage;
        return $this;
    }
    /**
     * Get SurchargeAmount value
     * @return string|null
     */
    public function getSurchargeAmount()
    {
        return $this->SurchargeAmount;
    }
    /**
     * Set SurchargeAmount value
     * @param string $surchargeAmount
     * @return \eBizCharge\StructType\CalculateSurchargeAmountResponse
     */
    public function setSurchargeAmount($surchargeAmount = null)
    {
        // validation for constraint: string
        if (!is_null($surchargeAmount) && !is_string($surchargeAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($surchargeAmount, true), gettype($surchargeAmount)), __LINE__);
        }
        $this->SurchargeAmount = $surchargeAmount;
        return $this;
    }
    /**
     * Get SurchargeCaption value
     * @return string|null
     */
    public function getSurchargeCaption()
    {
        return $this->SurchargeCaption;
    }
    /**
     * Set SurchargeCaption value
     * @param string $surchargeCaption
     * @return \eBizCharge\StructType\CalculateSurchargeAmountResponse
     */
    public function setSurchargeCaption($surchargeCaption = null)
    {
        // validation for constraint: string
        if (!is_null($surchargeCaption) && !is_string($surchargeCaption)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($surchargeCaption, true), gettype($surchargeCaption)), __LINE__);
        }
        $this->SurchargeCaption = $surchargeCaption;
        return $this;
    }
    /**
     * Get SurchargeTermsNote value
     * @return string|null
     */
    public function getSurchargeTermsNote()
    {
        return $this->SurchargeTermsNote;
    }
    /**
     * Set SurchargeTermsNote value
     * @param string $surchargeTermsNote
     * @return \eBizCharge\StructType\CalculateSurchargeAmountResponse
     */
    public function setSurchargeTermsNote($surchargeTermsNote = null)
    {
        // validation for constraint: string
        if (!is_null($surchargeTermsNote) && !is_string($surchargeTermsNote)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($surchargeTermsNote, true), gettype($surchargeTermsNote)), __LINE__);
        }
        $this->SurchargeTermsNote = $surchargeTermsNote;
        return $this;
    }
}
