<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SalesOrderResponse StructType
 * @subpackage Structs
 */
class SalesOrderResponse extends AbstractStructBase
{
    /**
     * The StatusCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $StatusCode;
    /**
     * The ErrorCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ErrorCode;
    /**
     * The SalesOrderNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SalesOrderNumber;
    /**
     * The SalesOrderInternalId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SalesOrderInternalId;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Status;
    /**
     * The Error
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Error;
    /**
     * Constructor method for SalesOrderResponse
     * @uses SalesOrderResponse::setStatusCode()
     * @uses SalesOrderResponse::setErrorCode()
     * @uses SalesOrderResponse::setSalesOrderNumber()
     * @uses SalesOrderResponse::setSalesOrderInternalId()
     * @uses SalesOrderResponse::setStatus()
     * @uses SalesOrderResponse::setError()
     * @param int $statusCode
     * @param int $errorCode
     * @param string $salesOrderNumber
     * @param string $salesOrderInternalId
     * @param string $status
     * @param string $error
     */
    public function __construct($statusCode = null, $errorCode = null, $salesOrderNumber = null, $salesOrderInternalId = null, $status = null, $error = null)
    {
        $this
            ->setStatusCode($statusCode)
            ->setErrorCode($errorCode)
            ->setSalesOrderNumber($salesOrderNumber)
            ->setSalesOrderInternalId($salesOrderInternalId)
            ->setStatus($status)
            ->setError($error);
    }
    /**
     * Get StatusCode value
     * @return int
     */
    public function getStatusCode()
    {
        return $this->StatusCode;
    }
    /**
     * Set StatusCode value
     * @param int $statusCode
     * @return \eBizCharge\StructType\SalesOrderResponse
     */
    public function setStatusCode($statusCode = null)
    {
        // validation for constraint: int
        if (!is_null($statusCode) && !(is_int($statusCode) || ctype_digit($statusCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($statusCode, true), gettype($statusCode)), __LINE__);
        }
        $this->StatusCode = $statusCode;
        return $this;
    }
    /**
     * Get ErrorCode value
     * @return int
     */
    public function getErrorCode()
    {
        return $this->ErrorCode;
    }
    /**
     * Set ErrorCode value
     * @param int $errorCode
     * @return \eBizCharge\StructType\SalesOrderResponse
     */
    public function setErrorCode($errorCode = null)
    {
        // validation for constraint: int
        if (!is_null($errorCode) && !(is_int($errorCode) || ctype_digit($errorCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($errorCode, true), gettype($errorCode)), __LINE__);
        }
        $this->ErrorCode = $errorCode;
        return $this;
    }
    /**
     * Get SalesOrderNumber value
     * @return string|null
     */
    public function getSalesOrderNumber()
    {
        return $this->SalesOrderNumber;
    }
    /**
     * Set SalesOrderNumber value
     * @param string $salesOrderNumber
     * @return \eBizCharge\StructType\SalesOrderResponse
     */
    public function setSalesOrderNumber($salesOrderNumber = null)
    {
        // validation for constraint: string
        if (!is_null($salesOrderNumber) && !is_string($salesOrderNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesOrderNumber, true), gettype($salesOrderNumber)), __LINE__);
        }
        $this->SalesOrderNumber = $salesOrderNumber;
        return $this;
    }
    /**
     * Get SalesOrderInternalId value
     * @return string|null
     */
    public function getSalesOrderInternalId()
    {
        return $this->SalesOrderInternalId;
    }
    /**
     * Set SalesOrderInternalId value
     * @param string $salesOrderInternalId
     * @return \eBizCharge\StructType\SalesOrderResponse
     */
    public function setSalesOrderInternalId($salesOrderInternalId = null)
    {
        // validation for constraint: string
        if (!is_null($salesOrderInternalId) && !is_string($salesOrderInternalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesOrderInternalId, true), gettype($salesOrderInternalId)), __LINE__);
        }
        $this->SalesOrderInternalId = $salesOrderInternalId;
        return $this;
    }
    /**
     * Get Status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \eBizCharge\StructType\SalesOrderResponse
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get Error value
     * @return string|null
     */
    public function getError()
    {
        return $this->Error;
    }
    /**
     * Set Error value
     * @param string $error
     * @return \eBizCharge\StructType\SalesOrderResponse
     */
    public function setError($error = null)
    {
        // validation for constraint: string
        if (!is_null($error) && !is_string($error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($error, true), gettype($error)), __LINE__);
        }
        $this->Error = $error;
        return $this;
    }
}
